git-rebase.shon commit git-svn: add support for --stat in the log command (488a63e)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30
  31SUBDIRECTORY_OK=Yes
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest=$GIT_DIR/.dotest-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git-ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget update-index?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        if test -n "`git-diff-index HEAD`"
  63        then
  64                if ! git-commit -C "`cat $dotest/current`"
  65                then
  66                        echo "Commit failed, please do not call \"git commit\""
  67                        echo "directly, but instead do one of the following: "
  68                        die "$RESOLVEMSG"
  69                fi
  70                printf "Committed: %0${prec}d" $msgnum
  71        else
  72                printf "Already applied: %0${prec}d" $msgnum
  73        fi
  74        echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
  75                                sed 's/^[a-f0-9]\+ //'`
  76
  77        prev_head=`git-rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat $dotest/cmt.$1)"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git-rev-parse --verify HEAD)
  90        cmt_name=$(git-symbolic-ref HEAD)
  91        msgnum=$(cat $dotest/msgnum)
  92        end=$(cat $dotest/end)
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                test -d "$GIT_DIR/rr-cache" && git-rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118finish_rb_merge () {
 119        rm -r "$dotest"
 120        echo "All done."
 121}
 122
 123while case "$#" in 0) break ;; esac
 124do
 125        case "$1" in
 126        --continue)
 127                diff=$(git-diff-files)
 128                case "$diff" in
 129                ?*)     echo "You must edit all merge conflicts and then"
 130                        echo "mark them as resolved using git update-index"
 131                        exit 1
 132                        ;;
 133                esac
 134                if test -d "$dotest"
 135                then
 136                        prev_head="`cat $dotest/prev_head`"
 137                        end="`cat $dotest/end`"
 138                        msgnum="`cat $dotest/msgnum`"
 139                        onto="`cat $dotest/onto`"
 140                        continue_merge
 141                        while test "$msgnum" -le "$end"
 142                        do
 143                                call_merge "$msgnum"
 144                                continue_merge
 145                        done
 146                        finish_rb_merge
 147                        exit
 148                fi
 149                git am --resolved --3way --resolvemsg="$RESOLVEMSG"
 150                exit
 151                ;;
 152        --skip)
 153                if test -d "$dotest"
 154                then
 155                        if test -d "$GIT_DIR/rr-cache"
 156                        then
 157                                git-rerere clear
 158                        fi
 159                        prev_head="`cat $dotest/prev_head`"
 160                        end="`cat $dotest/end`"
 161                        msgnum="`cat $dotest/msgnum`"
 162                        msgnum=$(($msgnum + 1))
 163                        onto="`cat $dotest/onto`"
 164                        while test "$msgnum" -le "$end"
 165                        do
 166                                call_merge "$msgnum"
 167                                continue_merge
 168                        done
 169                        finish_rb_merge
 170                        exit
 171                fi
 172                git am -3 --skip --resolvemsg="$RESOLVEMSG"
 173                exit
 174                ;;
 175        --abort)
 176                if test -d "$GIT_DIR/rr-cache"
 177                then
 178                        git-rerere clear
 179                fi
 180                if test -d "$dotest"
 181                then
 182                        rm -r "$dotest"
 183                elif test -d .dotest
 184                then
 185                        rm -r .dotest
 186                else
 187                        die "No rebase in progress?"
 188                fi
 189                git reset --hard ORIG_HEAD
 190                exit
 191                ;;
 192        --onto)
 193                test 2 -le "$#" || usage
 194                newbase="$2"
 195                shift
 196                ;;
 197        -M|-m|--m|--me|--mer|--merg|--merge)
 198                do_merge=t
 199                ;;
 200        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 201                --strateg=*|--strategy=*|\
 202        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 203                case "$#,$1" in
 204                *,*=*)
 205                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 206                1,*)
 207                        usage ;;
 208                *)
 209                        strategy="$2"
 210                        shift ;;
 211                esac
 212                do_merge=t
 213                ;;
 214        -v|--verbose)
 215                verbose=t
 216                ;;
 217        -C*)
 218                git_am_opt=$1
 219                shift
 220                ;;
 221        -*)
 222                usage
 223                ;;
 224        *)
 225                break
 226                ;;
 227        esac
 228        shift
 229done
 230
 231# Make sure we do not have .dotest
 232if test -z "$do_merge"
 233then
 234        if mkdir .dotest
 235        then
 236                rmdir .dotest
 237        else
 238                echo >&2 '
 239It seems that I cannot create a .dotest directory, and I wonder if you
 240are in the middle of patch application or another rebase.  If that is not
 241the case, please rm -fr .dotest and run me again.  I am stopping in case
 242you still have something valuable there.'
 243                exit 1
 244        fi
 245else
 246        if test -d "$dotest"
 247        then
 248                die "previous dotest directory $dotest still exists." \
 249                        'try git-rebase < --continue | --abort >'
 250        fi
 251fi
 252
 253# The tree must be really really clean.
 254git-update-index --refresh || exit
 255diff=$(git-diff-index --cached --name-status -r HEAD)
 256case "$diff" in
 257?*)     echo "cannot rebase: your index is not up-to-date"
 258        echo "$diff"
 259        exit 1
 260        ;;
 261esac
 262
 263# The upstream head must be given.  Make sure it is valid.
 264upstream_name="$1"
 265upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 266    die "invalid upstream $upstream_name"
 267
 268# If a hook exists, give it a chance to interrupt
 269if test -x "$GIT_DIR/hooks/pre-rebase"
 270then
 271        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 272                echo >&2 "The pre-rebase hook refused to rebase."
 273                exit 1
 274        }
 275fi
 276
 277# If the branch to rebase is given, first switch to it.
 278case "$#" in
 2792)
 280        branch_name="$2"
 281        git-checkout "$2" || usage
 282        ;;
 283*)
 284        if branch_name=`git symbolic-ref -q HEAD`
 285        then
 286                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 287        else
 288                branch_name=HEAD ;# detached
 289        fi
 290        ;;
 291esac
 292branch=$(git-rev-parse --verify "${branch_name}^0") || exit
 293
 294# Make sure the branch to rebase onto is valid.
 295onto_name=${newbase-"$upstream_name"}
 296onto=$(git-rev-parse --verify "${onto_name}^0") || exit
 297
 298# Now we are rebasing commits $upstream..$branch on top of $onto
 299
 300# Check if we are already based on $onto, but this should be
 301# done only when upstream and onto are the same.
 302mb=$(git-merge-base "$onto" "$branch")
 303if test "$upstream" = "$onto" && test "$mb" = "$onto"
 304then
 305        echo >&2 "Current branch $branch_name is up to date."
 306        exit 0
 307fi
 308
 309if test -n "$verbose"
 310then
 311        echo "Changes from $mb to $onto:"
 312        git-diff-tree --stat --summary "$mb" "$onto"
 313fi
 314
 315# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 316echo "First, rewinding head to replay your work on top of it..."
 317git-reset --hard "$onto"
 318
 319# If the $onto is a proper descendant of the tip of the branch, then
 320# we just fast forwarded.
 321if test "$mb" = "$branch"
 322then
 323        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 324        exit 0
 325fi
 326
 327if test -z "$do_merge"
 328then
 329        git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 330        git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
 331        exit $?
 332fi
 333
 334# start doing a rebase with git-merge
 335# this is rename-aware if the recursive (default) strategy is used
 336
 337mkdir -p "$dotest"
 338echo "$onto" > "$dotest/onto"
 339echo "$onto_name" > "$dotest/onto_name"
 340prev_head=`git-rev-parse HEAD^0`
 341echo "$prev_head" > "$dotest/prev_head"
 342
 343msgnum=0
 344for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
 345                        | @@PERL@@ -e 'print reverse <>'`
 346do
 347        msgnum=$(($msgnum + 1))
 348        echo "$cmt" > "$dotest/cmt.$msgnum"
 349done
 350
 351echo 1 >"$dotest/msgnum"
 352echo $msgnum >"$dotest/end"
 353
 354end=$msgnum
 355msgnum=1
 356
 357while test "$msgnum" -le "$end"
 358do
 359        call_merge "$msgnum"
 360        continue_merge
 361done
 362
 363finish_rb_merge